<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-etape', params: { profil: 'admin' } }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">Modification d'une étape</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-etape :etape="etape" />
      <div class="columns is-centered">
        <b-button class="button has-text-weight-semibold" type="is-primary" native-type="submit">
          Enregistrer les modifications
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import newEtape from '~/components/mixins/etapeMixin';
import MtChampsFormEtape from '~/components/dashboard/etape/champs-from-etape';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormEtape,
  },
  async asyncData(context) {
    const etape = Object.assign(newEtape(), await context.$api.etapes.get(context.params.id));
    return {
      etape,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.etapes.put(this.etape.id, this.etape);
        this.$router.push({ name: 'profil-dashboard-etape', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.button {
  margin-top: 1rem;
}
</style>
